<script lang="ts" setup>
import { useUserStore } from "@/stores/user";
import { onMounted, ref } from "vue";
import type { VForm } from "vuetify/components";
const form = ref<VForm | null>(null);
const userStore = useUserStore();
const reset = () => {
  form.value?.reset();}
async function save() {
  const { valid } = await form.value!.validate();
  if (valid) {
    await userStore.saveUser();
  }
  
}

</script>
<template>
  <v-dialog v-model="userStore.dialog" persistent width="500">
    <v-card>
      <v-card-title class="text-center">Nova-Consoler</v-card-title>
      <v-card-title class="text-center">สมัครสมาชิก</v-card-title>
      <v-card-text>
        <v-form ref="form">
          <v-container>


            <v-row>
              <v-col><span>ชื่อสมาชิก</span></v-col>
              <v-col cols="8"><v-text-field label="ชื่อสมาชิก*" required v-model="userStore.editedUser.name"
                  :rules="[
                    (v) => !!v || 'ชื่อสมาชิกห้ามว่าง',
                    (v) => v.length >= 3 || 'ชื่อสมาชิกต้องมีตัวอักษรมากกว่าหรือเท่ากับ 3 ตัวขึ้นไป',
                  ]"></v-text-field></v-col>
            </v-row>
            <v-row>
              <v-col><span>รหัสผ่าน</span></v-col>
              <v-col cols="8"><v-text-field label="รหัสผ่าน*" required
                  v-model="userStore.editedUser.password" :rules="[
                    (v) => !!v || 'รหัสผ่านห้ามว่าง',
                    (v) => v.length >= 3 || 'รหัสผ่านต้องมีตัวอักษรมากกว่าหรือเท่ากับ 3 ตัวขึ้นไป',
                  ]"></v-text-field></v-col>
            </v-row>
            <v-row>
              <v-col><span>เบอร์โทรศัพท์</span></v-col>
              <v-col cols="8"><v-text-field label="เบอร์โทรศัพท์*" required v-model="userStore.editedUser.telNumber"
                  :rules="[
                    (v) => !!v || 'เบอร์โทรศัพท์ห้ามว่าง',
                    (v) => v.length == 10 || 'เบอร์โทรศัพท์ต้องมีตัวอักษรเท่ากับ 10 ตัว',
                  ]"></v-text-field></v-col>
            </v-row>
            <v-row>
              <v-col><span>ที่อยู่</span></v-col>
              <v-col cols="8"><v-text-field label="ที่อยู่*" required v-model="userStore.editedUser.address"
                  :rules="[
                    (v) => !!v || 'ที่อยู่ห้ามว่าง',

                  ]"></v-text-field></v-col>
            </v-row>
            <v-row>
              <v-col><span>หมายเลขบัตรเครดิต</span></v-col>
              <v-col cols="8"><v-text-field label="หมายเลขบัตรเครดิต*" required v-model="userStore.editedUser.cd_creditcardnumber"
                  :rules="[
                    (v) => !!v || 'หมายเลขบัตรเครดิตห้ามว่าง',
                    (v) => v.length == 13 || 'หมายเลขบัตรเครดิตต้องมีตัวอักษรเท่ากับ 13 ตัว',
                  ]"></v-text-field></v-col>
            
            </v-row>
            <v-row>
              <v-col><span>วันที่บัตรหมดอายุ</span></v-col>
              <v-col cols="8"><v-text-field label="วันที่บัตรหมดอายุ*" required v-model="userStore.editedUser.cd_expirationdate"
                  :rules="[
                    (v) => !!v || 'วันที่บัตรหมดอายุห้ามว่าง',

                  ]"></v-text-field></v-col>
            
            </v-row>
            <v-row>
              <v-col><span>ชื่อในบัตรเครดิต</span></v-col>
              <v-col cols="8"><v-text-field label="ชื่อในบัตรเครดิต*" required v-model="userStore.editedUser.cd_name"
                  :rules="[
                    (v) => !!v || 'ชื่อในบัตรเครดิตห้ามว่าง',

                  ]"></v-text-field></v-col>
            
            </v-row>
            <v-row>
              <v-col><span>ที่อยู่ในบัตรเครดิต</span></v-col>
              <v-col cols="8"><v-text-field label="ที่อยู่ในบัตรเครดิต*" required v-model="userStore.editedUser.cd_address"
                  :rules="[
                    (v) => !!v || 'ที่อยู่ในบัตรเครดิตห้ามว่าง',

                  ]"></v-text-field></v-col>
            
            </v-row>
            <v-row>
              <v-col><span>หมายเลขCVV</span></v-col>
              <v-col cols="8"><v-text-field label="หมายเลขCVV*" required v-model="userStore.editedUser.cd_CVVnumber"
                  :rules="[
                    (v) => !!v || 'หมายเลขCVVห้ามว่าง',
                    (v) => v.length == 4 || 'หมายเลขบัตรเครดิตต้องมีตัวอักษรเท่ากับ 4 ตัว',
                  ]"></v-text-field></v-col>
            
            </v-row>



          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="error" variant="text" @click="userStore.dialog = false">
          ปิด
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save"> สมัครสมาชิก </v-btn>
      </v-card-actions>
  </v-card>
</v-dialog></template>
